### crd-leetcode-cli

crd-leetcode-cli 提供将 [leetcode](https://leetcode-cn.com/) 中已 AC 的题目转化为 markdown 表格的能力。

### Install

执行 `yarn add crd-leetcode-cli -g`, 国内用户可以执行 `cnpm install crd-leetcode-cli -g`

### Usage

```
leetcode download       // 增量拉取 AC 题目(若无登录, 则会先执行登录逻辑)
leetcode download -a    // 全量拉取 AC 题目
leetcode login          // 登录
leetcode logout         // 登出
```

> [接入项目示例](https://github.com/MuYunyun/blog/blob/master/package.json#L8-L9)

### Render Markdown Table Customly

插件提供了自定义渲染 markdown table 的能力。

* 在项目根目录创建 [config.js](https://github.com/MuYunyun/blog/blob/master/config.js) 文件。
* 在 config.js 内自定义生成 markdown 的 [transform_markdown_table](https://github.com/MuYunyun/blog/blob/master/config.js#L5-L22) 函数。

```js
const transform_markdown_table = (dataArr) => {
  const beforeDescription = `The markdown table is generated by [crd-leetcode-cli](https://github.com/MuYunyun/create-react-doc/tree/master/packages/leetcode-cli)`;
  let result = beforeDescription + '\n' +
    '| # | Title | Explanation | Difficulty | Type |' +
    '\n' +
    '|:---:|:---:|:---:|:---:|:---:|';

  for (let i = 0; i < dataArr.length; i++) {
    result += `\n| ${dataArr[i].questionId} | [${dataArr[i].title
      }](https://leetcode.com/problems/${dataArr[i].titleSlug
      }/) | [Analyze](https://github.com/MuYunyun/blog/blob/master/LeetCode/${dataArr[i].questionId
      }.${dataArr[i].title.split(' ').join('_')}.md) | ${dataArr[i].difficulty
      } | ${dataArr[i].topicTags} |`;
  }
  return result;
};

module.exports = { transform_markdown_table }
```

通过自定义 transform_markdown_table 函数, 便可得到如下 [markdown table](https://github.com/MuYunyun/blog/tree/master/LeetCode):

![](http://with.muyunyun.cn/0dd6ef8677ddcbd904cff9a23722df18.jpg)

### Technology Details

* 使用 [puppeteer](https://github.com/puppeteer/puppeteer) 登录 leetcode 获取 cookie 信息。
  * ![](http://with.muyunyun.cn/f9301658ff81e6d47dcaab3684cab1ce.jpg)
* 获取 cookie 后, 使用 [graphql-request](https://github.com/prisma-labs/graphql-request) 调用 graphql 接口获取题目详情信息。
* 自定义生成 [markdown table](https://github.com/MuYunyun/blog/tree/master/LeetCode)。
